/* libnih
 *
 * Copyright © 2008 Scott James Remnant <scott@netsplit.com>.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
 */

#ifndef DBUS__COM_NETSPLIT_NIH_TEST_PROXY_H
#define DBUS__COM_NETSPLIT_NIH_TEST_PROXY_H

#include <dbus/dbus.h>

#include <nih/macros.h>
#include <nih/dbus.h>


NIH_BEGIN_EXTERN

int proxy_test_method        (NihDBusProxy *proxy, const char *input, int32_t flags, char **output)
	__attribute__ ((warn_unused_result));
int proxy_test_async_method  (NihDBusProxy *proxy, const char *input, int32_t flags, char **output)
	__attribute__ ((warn_unused_result));
int proxy_byte_to_str        (NihDBusProxy *proxy, uint8_t input, char **output)
	__attribute__ ((warn_unused_result));
int proxy_str_to_byte        (NihDBusProxy *proxy, const char *input, uint8_t *output)
	__attribute__ ((warn_unused_result));
int proxy_boolean_to_str     (NihDBusProxy *proxy, int input, char **output)
	__attribute__ ((warn_unused_result));
int proxy_str_to_boolean     (NihDBusProxy *proxy, const char *input, int *output)
	__attribute__ ((warn_unused_result));
int proxy_int16_to_str       (NihDBusProxy *proxy, int16_t input, char **output)
	__attribute__ ((warn_unused_result));
int proxy_str_to_int16       (NihDBusProxy *proxy, const char *input, int16_t *output)
	__attribute__ ((warn_unused_result));
int proxy_uint16_to_str      (NihDBusProxy *proxy, uint16_t input, char **output)
	__attribute__ ((warn_unused_result));
int proxy_str_to_uint16      (NihDBusProxy *proxy, const char *input, uint16_t *output)
	__attribute__ ((warn_unused_result));
int proxy_int32_to_str       (NihDBusProxy *proxy, int32_t input, char **output)
	__attribute__ ((warn_unused_result));
int proxy_str_to_int32       (NihDBusProxy *proxy, const char *input, int32_t *output)
	__attribute__ ((warn_unused_result));
int proxy_uint32_to_str      (NihDBusProxy *proxy, uint32_t input, char **output)
	__attribute__ ((warn_unused_result));
int proxy_str_to_uint32      (NihDBusProxy *proxy, const char *input, uint32_t *output)
	__attribute__ ((warn_unused_result));
int proxy_int64_to_str       (NihDBusProxy *proxy, int64_t input, char **output)
	__attribute__ ((warn_unused_result));
int proxy_str_to_int64       (NihDBusProxy *proxy, const char *input, int64_t *output)
	__attribute__ ((warn_unused_result));
int proxy_uint64_to_str      (NihDBusProxy *proxy, uint64_t input, char **output)
	__attribute__ ((warn_unused_result));
int proxy_str_to_uint64      (NihDBusProxy *proxy, const char *input, uint64_t *output)
	__attribute__ ((warn_unused_result));
int proxy_double_to_str      (NihDBusProxy *proxy, double input, char **output)
	__attribute__ ((warn_unused_result));
int proxy_str_to_double      (NihDBusProxy *proxy, const char *input, double *output)
	__attribute__ ((warn_unused_result));
int proxy_object_path_to_str (NihDBusProxy *proxy, const char *input, char **output)
	__attribute__ ((warn_unused_result));
int proxy_str_to_object_path (NihDBusProxy *proxy, const char *input, char **output)
	__attribute__ ((warn_unused_result));
int proxy_signature_to_str   (NihDBusProxy *proxy, const char *input, char **output)
	__attribute__ ((warn_unused_result));
int proxy_str_to_signature   (NihDBusProxy *proxy, const char *input, char **output)
	__attribute__ ((warn_unused_result));
int proxy_int32_array_to_str (NihDBusProxy *proxy, const int32_t *input, size_t input_len, char **output)
	__attribute__ ((warn_unused_result));
int proxy_str_to_int32_array (NihDBusProxy *proxy, const char *input, int32_t **output, size_t *output_len)
	__attribute__ ((warn_unused_result));
int proxy_str_array_to_str   (NihDBusProxy *proxy, char * const *input, char **output)
	__attribute__ ((warn_unused_result));
int proxy_str_to_str_array   (NihDBusProxy *proxy, const char *input, char ***output)
	__attribute__ ((warn_unused_result));
int proxy_emit_signal        (NihDBusProxy *proxy, int32_t signum)
	__attribute__ ((warn_unused_result));

NIH_END_EXTERN

#endif /* DBUS__COM_NETSPLIT_NIH_TEST_PROXY_H */

